<template>
  <VContainer
    class="page-cnpj fill-height pa-0"
    fluid
  >
    <VLayout column>
      <VFlex
        xs12
        d-flex
        align-center
      >
        <VLayout
          row
          wrap
          justify-center
        >
          <VForm
            ref="form"
            class="px-4"
          >
            <p class="display-3 base--color">
              <VIcon
                :size="60"
                color="#3a8970"
              >
                fa-building
              </VIcon> <b>Localizador de CNPJ</b>
            </p>

            <VTextField
              v-model="cnpj"
              v-mask="'##.###.###/####-##'"
              label="CNPJ..."
              color="#3a8970"
              :rules="[
                v => v ? (v.length < 1 || v.length > 17) || 'CNPJ deve conter 14 digitos' : true,
              ]"
              :loading="loading"
              outlined
              autofocus
              clearable
            >
              <template v-slot:append-outer>
                <VBtn
                  class="white--text"
                  color="#3a8970"
                  large
                  rounded
                  :disabled="isForm"
                  :loading="loading"
                  @click="submit"
                >
                  Localizar
                </VBtn>
              </template>
            </VTextField>
          </VForm>
        </VLayout>
      </VFlex>
      <VFlex
        xs12
        d-flex
        justify-center
        bg--content
      >
        <VFadeTransition
          group
          class="d-flex"
        >
          <VSheet
            v-if="data.length > 0"
            key="fade-1"
            class="ma-auto"
            max-width="900px"
            color="transparent"
          >
            <VSlideGroup
              v-model="model"
              class="pa-4"
              active-class="success"
              show-arrows
              center-active
            >
              <VSlideItem
                v-for="(d, i) in data"
                :key="`cnpj-${i}`"
                v-slot="{ active, toggle }"
                :value="i"
              >
                <VCard
                  class="ma-4"
                  :height="250"
                  :width="250"
                  @click="toggle"
                >
                  <VScaleTransition
                    class="layout align-center fill-height justify-center"
                    group
                    hide-on-leave
                  >
                    <VIcon
                      v-if="active"
                      key="scale-1"
                      color="white"
                      size="48"
                    >
                      fa-check-circle
                    </VIcon>
                    <VCardText
                      v-else
                      key="scale-2"
                      class="base--color"
                      style="white-space: normal; font-size: 16px"
                    >
                      <p>
                        <b>{{ d.nome }}</b>
                        <br>
                        Razão social
                      </p>
                      <p>
                        <b>{{ d.cnpj }}</b>
                        <br>
                        CNPJ
                      </p>
                      <p class="mb-0">
                        <b>
                          {{ d.logradouro }}
                        </b>
                        <br>
                        Endereço
                      </p>
                    </VCardText>
                  </VScaleTransition>
                </VCard>
              </VSlideItem>
            </VSlideGroup>
          </VSheet>
          <VLayout
            v-else
            key="fade-2"
            column
            align-center
            justify-center
            title
          >
            <p>Localize acima a primeira empresa</p>
            <img
              src="@/assets/common/search-cnpj.png"
              width="200px"
            >
          </Vlayout>
        </VFadeTransition>
      </VFlex>
    </VLayout>

    <!-- Oções: data[] -->
    <VBottomSheet v-model="sheet">
      <VList>
        <VSubheader>Escolha uma opção:</VSubheader>
        <VListItem
          link
          @click="selectedModel = data[model]; sheet = false"
        >
          <VListItemAvatar>
            <VAvatar
              size="32px"
              tile
            >
              <VIcon>fa-map-signs</VIcon>
            </VAvatar>
          </VListItemAvatar>
          <VListItemTitle>Abrir mapa</VListItemTitle>
        </VListItem>
        <VListItem
          link
          @click="$delete(data, model); sheet = false"
        >
          <VListItemAvatar>
            <VAvatar
              size="32px"
              tile
            >
              <VIcon>fa-trash-alt</VIcon>
            </VAvatar>
          </VListItemAvatar>
          <VListItemTitle>Deletar opção</VListItemTitle>
        </VListItem>
      </VList>
    </VBottomSheet>

    <!-- card: selectModel -->
    <VSlideXTransition>
      <VCard
        v-if="selectedModel !== null"
        class="card-model"
        color="white"
        :width="250"
        :height="250"
        :elevation="4"
      >
        <VCardText
          class="base--color"
          style="white-space: normal; font-size: 16px"
        >
          <p>
            <b>{{ selectedModel.nome }}</b>
            <br>
            Razão social
          </p>
          <p>
            <b>{{ selectedModel.cnpj }}</b>
            <br>
            CNPJ
          </p>
          <p class="mb-0">
            <b>
              {{ selectedModel.logradouro }}
            </b>
            <br>
            Endereço
          </p>
        </VCardText>

        <VBtn
          absolute
          fab
          bottom
          right
          color="error"
          @click="selectedModel = null"
        >
          <VIcon>fa-times</VIcon>
        </VBtn>
      </VCard>
    </VSlideXTransition>
  </VContainer>
</template>

<script lang="ts">
import {
  Component, Vue, Mutation, Watch,
} from 'nuxt-property-decorator';

const jsonpAdapter = require('axios-jsonp');

@Component({
  watch: {
    data(val: any[]) {
      localStorage.setItem('data-cnpj', JSON.stringify(val));
    },
  },
})
export default class Index extends Vue {
  @Mutation
  setMsg!: (key: Object) => void

  @Mutation
  setBoolMsg!: (bool: boolean) => void

  cnpj: string | null = ''

  model: null | number = null

  selectedModel: null | Object = null

  data: any[] = []

  count = 0

  loading = false

  sheet = false

  get form() {
    const { cnpj } = this;
    if (cnpj) return cnpj.replace(/[^\w\s]/gi, '');
    return '';
  }

  get isForm() {
    return this.form.length < 14;
  }

  created() {
    const data = localStorage.getItem('data-cnpj');
    if (data !== null) {
      this.data = JSON.parse(data);
    }
  }

  async submit() {
    if ((this.$refs.form as any).validate()) {
      if (this.isForm) {
        this.onMsg('CNPJ deve conter 14 digitos');
      } else {
        this.loading = true;

        // Fix Error 429 - Limite de Consultas por Minuto
        if (this.count === 3) {
          this.onMsg('Aguarde 1min que os dados serão processados.', 'warning', 0, false);

          setTimeout(() => {
            this.setBoolMsg(false);
            this.count = 0;
            this.submit();
          }, 60000);
        } else {
          try {
            const { data } = await this.$axios.get(`/cnpj/${this.form}`, { adapter: jsonpAdapter });

            if (data.status === 'ERROR') {
              this.onMsg(data.message);
            } else {
              this.data.push(data);
            }
          } catch ({ message }) {
            this.onMsg(message);
          }

          this.count += 1;
          this.loading = false;
        }
      }
    }
  }

  onMsg(message: string, color = 'error', timeout = 6000, btn = true) {
    this.setMsg({
      bool: true,
      color,
      message,
      timeout,
      btn,
    });
  }

  @Watch('sheet')
  changeSheet(bool: boolean) {
    if (!bool) this.model = null;
  }

  @Watch('model')
  changeModel(val: null | number) {
    if (val !== null) {
      this.sheet = true;
    }
  }
}
</script>

<style lang="stylus">
.page-cnpj
  .base--color
    color #3a8970 !important
  .v-input__append-outer
    margin-top 8px !important
  .bg--content
    color white
    background-image linear-gradient(to right top, #388669, #368b77, #379185, #3c9592, #459a9e)
  .card-model
    position fixed
    top 0
    left 0
    border-radius 0 0 24px 0
</style>
